// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _GOOCANVASMM_POLYLINEMODEL_H
#define _GOOCANVASMM_POLYLINEMODEL_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasmm/itemmodelsimple.h>
#include <goocanvasmm/points.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GooCanvasPolylineModel GooCanvasPolylineModel;
typedef struct _GooCanvasPolylineModelClass GooCanvasPolylineModelClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Goocanvas
{ class PolylineModel_Class; } // namespace Goocanvas
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Goocanvas
{


class PolylineModel : public Goocanvas::ItemModelSimple
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef PolylineModel CppObjectType;
  typedef PolylineModel_Class CppClassType;
  typedef GooCanvasPolylineModel BaseObjectType;
  typedef GooCanvasPolylineModelClass BaseClassType;

  // noncopyable
  PolylineModel(const PolylineModel&) = delete;
  PolylineModel& operator=(const PolylineModel&) = delete;

private:  friend class PolylineModel_Class;
  static CppClassType polylinemodel_class_;

protected:
  explicit PolylineModel(const Glib::ConstructParams& construct_params);
  explicit PolylineModel(GooCanvasPolylineModel* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  PolylineModel(PolylineModel&& src) noexcept;
  PolylineModel& operator=(PolylineModel&& src) noexcept;

  virtual ~PolylineModel() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GooCanvasPolylineModel*       gobj()       { return reinterpret_cast<GooCanvasPolylineModel*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GooCanvasPolylineModel* gobj() const { return reinterpret_cast<GooCanvasPolylineModel*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GooCanvasPolylineModel* gobj_copy();

private:

protected:

  PolylineModel(bool close_path, const Points& points);
  PolylineModel(double x1, double y1, double x2, double y2);

public:

  
  static Glib::RefPtr<PolylineModel> create(double x1, double y1, double x2, double y2);


  /** The length of the arrows, as a multiple of the line width.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_arrow_length() ;

/** The length of the arrows, as a multiple of the line width.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_arrow_length() const;

  /** The length of the arrow tip, as a multiple of the line width.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_arrow_tip_length() ;

/** The length of the arrow tip, as a multiple of the line width.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_arrow_tip_length() const;

  /** The width of the arrows, as a multiple of the line width.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_arrow_width() ;

/** The width of the arrows, as a multiple of the line width.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_arrow_width() const;

  /** If the last point should be connected to the first.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_close_path() ;

/** If the last point should be connected to the first.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_close_path() const;

  /** If an arrow should be displayed at the end of the polyline.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_end_arrow() ;

/** If an arrow should be displayed at the end of the polyline.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_end_arrow() const;

  /** The array of points.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Points > property_points() ;

/** The array of points.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Points > property_points() const;

  /** If an arrow should be displayed at the start of the polyline.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_start_arrow() ;

/** If an arrow should be displayed at the start of the polyline.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_start_arrow() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Goocanvas::PolylineModel
   */
  Glib::RefPtr<Goocanvas::PolylineModel> wrap(GooCanvasPolylineModel* object, bool take_copy = false);
}


#endif /* _GOOCANVASMM_POLYLINEMODEL_H */

